diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/erp-information.cc ns-3.34/src/wifi/model/non-ht/erp-information.cc
--- ns-3.33/src/wifi/model/non-ht/erp-information.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/erp-information.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,134 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2015 Sébastien Deronne
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "erp-information.h"
+
+namespace ns3 {
+
+ErpInformation::ErpInformation ()
+  : m_erpInformation (0),
+    m_erpSupported (0)
+{
+}
+
+WifiInformationElementId
+ErpInformation::ElementId () const
+{
+  return IE_ERP_INFORMATION;
+}
+
+void
+ErpInformation::SetErpSupported (uint8_t erpSupported)
+{
+  m_erpSupported = erpSupported;
+}
+
+void
+ErpInformation::SetBarkerPreambleMode (uint8_t barkerPreambleMode)
+{
+  m_erpInformation |= (barkerPreambleMode & 0x01) << 2;
+}
+
+void
+ErpInformation::SetUseProtection (uint8_t useProtection)
+{
+  m_erpInformation |= (useProtection & 0x01) << 1;
+}
+
+void
+ErpInformation::SetNonErpPresent (uint8_t nonErpPresent)
+{
+  m_erpInformation |= nonErpPresent & 0x01;
+}
+
+uint8_t
+ErpInformation::GetBarkerPreambleMode (void) const
+{
+  return ((m_erpInformation >> 2) & 0x01);
+}
+
+uint8_t
+ErpInformation::GetUseProtection (void) const
+{
+  return ((m_erpInformation >> 1) & 0x01);
+}
+
+uint8_t
+ErpInformation::GetNonErpPresent (void) const
+{
+  return (m_erpInformation & 0x01);
+}
+
+uint8_t
+ErpInformation::GetInformationFieldSize () const
+{
+  NS_ASSERT (m_erpSupported);
+  return 1;
+}
+
+Buffer::Iterator
+ErpInformation::Serialize (Buffer::Iterator i) const
+{
+  if (!m_erpSupported)
+    {
+      return i;
+    }
+  return WifiInformationElement::Serialize (i);
+}
+
+uint16_t
+ErpInformation::GetSerializedSize () const
+{
+  if (!m_erpSupported)
+    {
+      return 0;
+    }
+  return WifiInformationElement::GetSerializedSize ();
+}
+
+void
+ErpInformation::SerializeInformationField (Buffer::Iterator start) const
+{
+  if (m_erpSupported)
+    {
+      start.WriteU8 (m_erpInformation);
+    }
+}
+
+uint8_t
+ErpInformation::DeserializeInformationField (Buffer::Iterator start,
+                                             uint8_t length)
+{
+  Buffer::Iterator i = start;
+  m_erpInformation = i.ReadU8 ();
+  return length;
+}
+
+std::ostream &
+operator << (std::ostream &os, const ErpInformation &erpInformation)
+{
+  os <<  bool (erpInformation.GetBarkerPreambleMode ())
+     << "|" << bool (erpInformation.GetUseProtection ())
+     << "|" << bool (erpInformation.GetNonErpPresent ());
+
+  return os;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/erp-information.h ns-3.34/src/wifi/model/non-ht/erp-information.h
--- ns-3.33/src/wifi/model/non-ht/erp-information.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/erp-information.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,118 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2015 Sébastien Deronne
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef ERP_INFORMATION_H
+#define ERP_INFORMATION_H
+
+#include "ns3/wifi-information-element.h"
+
+namespace ns3 {
+
+/**
+ * \brief The ErpInformation Information Element
+ * \ingroup wifi
+ *
+ * This class knows how to serialise and deserialise the ErpInformation Information Element.
+ */
+class ErpInformation : public WifiInformationElement
+{
+public:
+  ErpInformation ();
+
+  // Implementations of pure virtual methods of WifiInformationElement
+  WifiInformationElementId ElementId () const override;
+  uint8_t GetInformationFieldSize () const override;
+  void SerializeInformationField (Buffer::Iterator start) const override;
+  uint8_t DeserializeInformationField (Buffer::Iterator start,
+                                       uint8_t length) override;
+
+  /* This information element is a bit special in that it is only
+     included if the STA is an ERP STA. To support this we
+     override the Serialize and GetSerializedSize methods of
+     WifiInformationElement. */
+  Buffer::Iterator Serialize (Buffer::Iterator start) const override;
+  uint16_t GetSerializedSize () const override;
+
+  /**
+   * Set the ERP supported field.
+   *
+   * \param erpSupported the ERP supported field in the ErpInformation information element
+   */
+  void SetErpSupported (uint8_t erpSupported);
+
+  /**
+   * Set the Barker_Preamble_Mode field in the ErpInformation information element.
+   *
+   * \param barkerPreambleMode the Barker_Preamble_Mode field in the ErpInformation information element
+   */
+  void SetBarkerPreambleMode (uint8_t barkerPreambleMode);
+  /**
+   * Set the Use_Protection field in the ErpInformation information element.
+   *
+   * \param useProtection the Use_Protection field in the ErpInformation information element
+   */
+  void SetUseProtection (uint8_t useProtection);
+  /**
+   * Set the Non_Erp_Present field in the ErpInformation information element.
+   *
+   * \param nonErpPresent the Non_Erp_Present field in the ErpInformation information element
+   */
+  void SetNonErpPresent (uint8_t nonErpPresent);
+
+  /**
+   * Return the Barker_Preamble_Mode field in the ErpInformation information element.
+   *
+   * \return the Barker_Preamble_Mode field in the ErpInformation information element
+   */
+  uint8_t GetBarkerPreambleMode (void) const;
+  /**
+   * Return the Use_Protection field in the ErpInformation information element.
+   *
+   * \return the Use_Protection field in the ErpInformation information element
+   */
+  uint8_t GetUseProtection (void) const;
+  /**
+   * Return the Non_Erp_Present field in the ErpInformation information element.
+   *
+   * \return the Non_Erp_Present field in the ErpInformation information element
+   */
+  uint8_t GetNonErpPresent (void) const;
+
+
+private:
+  uint8_t m_erpInformation; ///< ERP information
+
+  /// This is used to decide whether this element should be added to the frame or not
+  bool m_erpSupported;
+};
+
+/**
+ * output stream output operator
+ *
+ * \param os output stream
+ * \param erpInformation the ERP Information
+ *
+ * \returns output stream
+ */
+std::ostream &operator << (std::ostream &os, const ErpInformation &erpInformation);
+
+} //namespace ns3
+
+#endif /* ERP_INFORMATION_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/erp-ofdm-phy.cc ns-3.34/src/wifi/model/non-ht/erp-ofdm-phy.cc
--- ns-3.33/src/wifi/model/non-ht/erp-ofdm-phy.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/erp-ofdm-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,262 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Rediet <getachew.redieteab@orange.com>
+ *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
+ *          Mathieu Lacage <mathieu.lacage@sophia.inria.fr> (for logic ported from wifi-phy)
+ */
+
+#include <array>
+#include "erp-ofdm-phy.h"
+#include "erp-ofdm-ppdu.h"
+#include "ns3/wifi-psdu.h"
+#include "ns3/wifi-phy.h" //only used for static mode constructor
+#include "ns3/log.h"
+#include "ns3/assert.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("ErpOfdmPhy");
+
+/*******************************************************
+ *       ERP-OFDM PHY (IEEE 802.11-2016, clause 18)
+ *******************************************************/
+
+/* *NS_CHECK_STYLE_OFF* */
+const PhyEntity::ModulationLookupTable ErpOfdmPhy::m_erpOfdmModulationLookupTable {
+  // Unique name           Code rate           Constellation size
+  { "ErpOfdmRate6Mbps",  { WIFI_CODE_RATE_1_2, 2 } },
+  { "ErpOfdmRate9Mbps",  { WIFI_CODE_RATE_3_4, 2 } },
+  { "ErpOfdmRate12Mbps", { WIFI_CODE_RATE_1_2, 4 } },
+  { "ErpOfdmRate18Mbps", { WIFI_CODE_RATE_3_4, 4 } },
+  { "ErpOfdmRate24Mbps", { WIFI_CODE_RATE_1_2, 16 } },
+  { "ErpOfdmRate36Mbps", { WIFI_CODE_RATE_3_4, 16 } },
+  { "ErpOfdmRate48Mbps", { WIFI_CODE_RATE_2_3, 64 } },
+  { "ErpOfdmRate54Mbps", { WIFI_CODE_RATE_3_4, 64 } }
+};
+
+/// ERP OFDM rates in bits per second
+static const std::array<uint64_t, 8> s_erpOfdmRatesBpsList =
+    {  6000000,  9000000, 12000000, 18000000,
+      24000000, 36000000, 48000000, 54000000};
+
+/* *NS_CHECK_STYLE_ON* */
+
+/**
+ * Get the array of possible ERP OFDM rates.
+ *
+ * \return the ERP OFDM rates in bits per second
+ */
+const std::array<uint64_t, 8>& GetErpOfdmRatesBpsList (void)
+{
+  return s_erpOfdmRatesBpsList;
+};
+
+ErpOfdmPhy::ErpOfdmPhy ()
+  : OfdmPhy (OFDM_PHY_DEFAULT, false) //don't add OFDM modes to list
+{
+  NS_LOG_FUNCTION (this);
+  for (const auto & rate : GetErpOfdmRatesBpsList ())
+    {
+      WifiMode mode = GetErpOfdmRate (rate);
+      NS_LOG_LOGIC ("Add " << mode << " to list");
+      m_modeList.emplace_back (mode);
+    }
+}
+
+ErpOfdmPhy::~ErpOfdmPhy ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+WifiMode
+ErpOfdmPhy::GetHeaderMode (const WifiTxVector& txVector) const
+{
+  NS_ASSERT (txVector.GetMode ().GetModulationClass () == WIFI_MOD_CLASS_ERP_OFDM);
+  return GetErpOfdmRate6Mbps ();
+}
+
+Time
+ErpOfdmPhy::GetPreambleDuration (const WifiTxVector& /* txVector */) const
+{
+  return MicroSeconds (16); //L-STF + L-LTF
+}
+
+Time
+ErpOfdmPhy::GetHeaderDuration (const WifiTxVector& /* txVector */) const
+{
+  return MicroSeconds (4); //L-SIG
+}
+
+Ptr<WifiPpdu>
+ErpOfdmPhy::BuildPpdu (const WifiConstPsduMap & psdus, const WifiTxVector& txVector, Time /* ppduDuration */)
+{
+  NS_LOG_FUNCTION (this << psdus << txVector);
+  return Create<ErpOfdmPpdu> (psdus.begin ()->second, txVector, m_wifiPhy->GetPhyBand (),
+                              ObtainNextUid (txVector));
+}
+
+void
+ErpOfdmPhy::InitializeModes (void)
+{
+  for (const auto & rate : GetErpOfdmRatesBpsList ())
+    {
+      GetErpOfdmRate (rate);
+    }
+}
+
+WifiMode
+ErpOfdmPhy::GetErpOfdmRate (uint64_t rate)
+{
+  switch (rate)
+    {
+      case 6000000:
+        return GetErpOfdmRate6Mbps ();
+      case 9000000:
+        return GetErpOfdmRate9Mbps ();
+      case 12000000:
+        return GetErpOfdmRate12Mbps ();
+      case 18000000:
+        return GetErpOfdmRate18Mbps ();
+      case 24000000:
+        return GetErpOfdmRate24Mbps ();
+      case 36000000:
+        return GetErpOfdmRate36Mbps ();
+      case 48000000:
+        return GetErpOfdmRate48Mbps ();
+      case 54000000:
+        return GetErpOfdmRate54Mbps ();
+      default:
+        NS_ABORT_MSG ("Inexistent rate (" << rate << " bps) requested for ERP-OFDM");
+        return WifiMode ();
+    }
+}
+
+#define GET_ERP_OFDM_MODE(x, f) \
+WifiMode \
+ErpOfdmPhy::Get ## x (void) \
+{ \
+  static WifiMode mode = CreateErpOfdmMode (#x, f); \
+  return mode; \
+}; \
+
+GET_ERP_OFDM_MODE (ErpOfdmRate6Mbps,  true)
+GET_ERP_OFDM_MODE (ErpOfdmRate9Mbps,  false)
+GET_ERP_OFDM_MODE (ErpOfdmRate12Mbps, true)
+GET_ERP_OFDM_MODE (ErpOfdmRate18Mbps, false)
+GET_ERP_OFDM_MODE (ErpOfdmRate24Mbps, true)
+GET_ERP_OFDM_MODE (ErpOfdmRate36Mbps, false)
+GET_ERP_OFDM_MODE (ErpOfdmRate48Mbps, false)
+GET_ERP_OFDM_MODE (ErpOfdmRate54Mbps, false)
+#undef GET_ERP_OFDM_MODE
+
+WifiMode
+ErpOfdmPhy::CreateErpOfdmMode (std::string uniqueName, bool isMandatory)
+{
+  // Check whether uniqueName is in lookup table
+  const auto it = m_erpOfdmModulationLookupTable.find (uniqueName);
+  NS_ASSERT_MSG (it != m_erpOfdmModulationLookupTable.end (), "ERP-OFDM mode cannot be created because it is not in the lookup table!");
+
+  return WifiModeFactory::CreateWifiMode (uniqueName,
+                                          WIFI_MOD_CLASS_ERP_OFDM,
+                                          isMandatory,
+                                          MakeBoundCallback (&GetCodeRate, uniqueName),
+                                          MakeBoundCallback (&GetConstellationSize, uniqueName),
+                                          MakeBoundCallback (&GetPhyRate, uniqueName),
+                                          MakeCallback (&GetPhyRateFromTxVector),
+                                          MakeBoundCallback (&GetDataRate, uniqueName),
+                                          MakeCallback (&GetDataRateFromTxVector),
+                                          MakeCallback (&IsModeAllowed));
+}
+
+WifiCodeRate
+ErpOfdmPhy::GetCodeRate (const std::string& name)
+{
+  return m_erpOfdmModulationLookupTable.at (name).first;
+}
+
+uint16_t
+ErpOfdmPhy::GetConstellationSize (const std::string& name)
+{
+  return m_erpOfdmModulationLookupTable.at (name).second;
+}
+
+uint64_t
+ErpOfdmPhy::GetPhyRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+{
+  WifiCodeRate codeRate = GetCodeRate (name);
+  uint16_t constellationSize = GetConstellationSize (name);
+  uint64_t dataRate = OfdmPhy::CalculateDataRate (codeRate, constellationSize, channelWidth, guardInterval, nss);
+  return OfdmPhy::CalculatePhyRate (codeRate, dataRate);
+}
+
+uint64_t
+ErpOfdmPhy::GetPhyRateFromTxVector (const WifiTxVector& txVector, uint16_t /* staId */)
+{
+  return GetPhyRate (txVector.GetMode ().GetUniqueName (),
+                     txVector.GetChannelWidth (),
+                     txVector.GetGuardInterval (),
+                     txVector.GetNss ());
+}
+
+uint64_t
+ErpOfdmPhy::GetDataRateFromTxVector (const WifiTxVector& txVector, uint16_t /* staId */)
+{
+  return GetDataRate (txVector.GetMode ().GetUniqueName (),
+                      txVector.GetChannelWidth (),
+                      txVector.GetGuardInterval (),
+                      txVector.GetNss ());
+}
+
+uint64_t
+ErpOfdmPhy::GetDataRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+{
+  WifiCodeRate codeRate = GetCodeRate (name);
+  uint16_t constellationSize = GetConstellationSize (name);
+  return OfdmPhy::CalculateDataRate (codeRate, constellationSize, channelWidth, guardInterval, nss);
+}
+
+bool
+ErpOfdmPhy::IsModeAllowed (uint16_t /* channelWidth */, uint8_t /* nss */)
+{
+  return true;
+}
+
+uint32_t
+ErpOfdmPhy::GetMaxPsduSize (void) const
+{
+  return 4095;
+}
+
+} //namespace ns3
+
+namespace {
+
+/**
+ * Constructor class for ERP-OFDM modes
+ */
+static class ConstructorErpOfdm
+{
+public:
+  ConstructorErpOfdm ()
+  {
+    ns3::ErpOfdmPhy::InitializeModes ();
+    ns3::WifiPhy::AddStaticPhyEntity (ns3::WIFI_MOD_CLASS_ERP_OFDM, ns3::Create<ns3::ErpOfdmPhy> ());
+  }
+} g_constructor_erp_ofdm; ///< the constructor for ERP-OFDM modes
+
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/erp-ofdm-phy.h ns-3.34/src/wifi/model/non-ht/erp-ofdm-phy.h
--- ns-3.33/src/wifi/model/non-ht/erp-ofdm-phy.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/erp-ofdm-phy.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,220 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Rediet <getachew.redieteab@orange.com>
+ *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
+ *          Mathieu Lacage <mathieu.lacage@sophia.inria.fr> (for logic ported from wifi-phy)
+ */
+
+#ifndef ERP_OFDM_PHY_H
+#define ERP_OFDM_PHY_H
+
+#include "ofdm-phy.h"
+
+/**
+ * \file
+ * \ingroup wifi
+ * Declaration of ns3::ErpOfdmPhy class.
+ */
+
+namespace ns3 {
+
+/**
+ * \brief PHY entity for ERP-OFDM (11g)
+ * \ingroup wifi
+ *
+ * ERP-OFDM PHY is based on OFDM PHY.
+ * ERP-DSSS/CCK mode is not supported.
+ *
+ * Refer to IEEE 802.11-2016, clause 18.
+ */
+class ErpOfdmPhy : public OfdmPhy
+{
+public:
+  /**
+   * Constructor for ERP-OFDM PHY
+   */
+  ErpOfdmPhy ();
+  /**
+   * Destructor for ERP-OFDM PHY
+   */
+  virtual ~ErpOfdmPhy ();
+
+  Ptr<WifiPpdu> BuildPpdu (const WifiConstPsduMap & psdus, const WifiTxVector& txVector, Time ppduDuration) override;
+  uint32_t GetMaxPsduSize (void) const override;
+
+  /**
+   * Initialize all ERP-OFDM modes.
+   */
+  static void InitializeModes (void);
+  /**
+   * Return a WifiMode for ERP-OFDM
+   * corresponding to the provided rate.
+   *
+   * \param rate the rate in bps
+   * \return a WifiMode for ERP-OFDM
+   */
+  static WifiMode GetErpOfdmRate (uint64_t rate);
+
+  /**
+   * Return a WifiMode for ERP-OFDM at 6 Mbps.
+   *
+   * \return a WifiMode for ERP-OFDM at 6 Mbps
+   */
+  static WifiMode GetErpOfdmRate6Mbps (void);
+  /**
+   * Return a WifiMode for ERP-OFDM at 9 Mbps.
+   *
+   * \return a WifiMode for ERP-OFDM at 9 Mbps
+   */
+  static WifiMode GetErpOfdmRate9Mbps (void);
+  /**
+   * Return a WifiMode for ERP-OFDM at 12 Mbps.
+   *
+   * \return a WifiMode for ERP-OFDM at 12 Mbps
+   */
+  static WifiMode GetErpOfdmRate12Mbps (void);
+  /**
+   * Return a WifiMode for ERP-OFDM at 18 Mbps.
+   *
+   * \return a WifiMode for ERP-OFDM at 18 Mbps
+   */
+  static WifiMode GetErpOfdmRate18Mbps (void);
+  /**
+   * Return a WifiMode for ERP-OFDM at 24 Mbps.
+   *
+   * \return a WifiMode for ERP-OFDM at 24 Mbps
+   */
+  static WifiMode GetErpOfdmRate24Mbps (void);
+  /**
+   * Return a WifiMode for ERP-OFDM at 36 Mbps.
+   *
+   * \return a WifiMode for ERP-OFDM at 36 Mbps
+   */
+  static WifiMode GetErpOfdmRate36Mbps (void);
+  /**
+   * Return a WifiMode for ERP-OFDM at 48 Mbps.
+   *
+   * \return a WifiMode for ERP-OFDM at 48 Mbps
+   */
+  static WifiMode GetErpOfdmRate48Mbps (void);
+  /**
+   * Return a WifiMode for ERP-OFDM at 54 Mbps.
+   *
+   * \return a WifiMode for ERP-OFDM at 54 Mbps
+   */
+  static WifiMode GetErpOfdmRate54Mbps (void);
+
+  /**
+   * Return the WifiCodeRate from the ERP-OFDM mode's unique name using
+   * ModulationLookupTable. This is mainly used as a callback for
+   * WifiMode operation.
+   *
+   * \param name the unique name of the ERP-OFDM mode
+   * \return WifiCodeRate corresponding to the unique name
+   */
+  static WifiCodeRate GetCodeRate (const std::string& name);
+  /**
+   * Return the constellation size from the ERP-OFDM mode's unique name using
+   * ModulationLookupTable. This is mainly used as a callback for
+   * WifiMode operation.
+   *
+   * \param name the unique name of the ERP-OFDM mode
+   * \return constellation size corresponding to the unique name
+   */
+  static uint16_t GetConstellationSize (const std::string& name);
+  /**
+   * Return the PHY rate from the ERP-OFDM mode's unique name and
+   * the supplied parameters. This function calls OfdmPhy::CalculatePhyRate
+   * and is mainly used as a callback for WifiMode operation.
+   *
+   * \param name the unique name of the ERP-OFDM mode
+   * \param channelWidth the considered channel width in MHz
+   * \param guardInterval the considered guard interval duration in nanoseconds
+   * \param nss the considered number of streams
+   *
+   * \return the physical bit rate of this signal in bps.
+   */
+  static uint64_t GetPhyRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+  /**
+   * Return the PHY rate corresponding to
+   * the supplied TXVECTOR.
+   * This function is mainly used as a callback
+   * for WifiMode operation.
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the station ID (only here to have a common signature for all callbacks)
+   * \return the physical bit rate of this signal in bps.
+   */
+  static uint64_t GetPhyRateFromTxVector (const WifiTxVector& txVector, uint16_t staId);
+  /**
+   * Return the data rate corresponding to
+   * the supplied TXVECTOR.
+   * This function is mainly used as a callback
+   * for WifiMode operation.
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the station ID (only here to have a common signature for all callbacks)
+   * \return the data bit rate in bps.
+   */
+  static uint64_t GetDataRateFromTxVector (const WifiTxVector& txVector, uint16_t staId);
+  /**
+   * Return the data rate from the ERP-OFDM mode's unique name and
+   * the supplied parameters. This function calls OfdmPhy::CalculateDataRate
+   * and is mainly used as a callback for WifiMode operation.
+   *
+   * \param name the unique name of the ERP-OFDM mode
+   * \param channelWidth the considered channel width in MHz
+   * \param guardInterval the considered guard interval duration in nanoseconds
+   * \param nss the considered number of streams
+   *
+   * \return the data bit rate of this signal in bps.
+   */
+  static uint64_t GetDataRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+  /**
+   * Check whether the combination of <WifiMode, channel width, NSS> is allowed.
+   * This function is used as a callback for WifiMode operation, and always
+   * returns true since there is no limitation for any mode in ErpOfdmPhy.
+   *
+   * \param channelWidth the considered channel width in MHz
+   * \param nss the considered number of streams
+   * \returns true.
+   */
+  static bool IsModeAllowed (uint16_t channelWidth, uint8_t nss);
+
+private:
+  WifiMode GetHeaderMode (const WifiTxVector& txVector) const override;
+  Time GetPreambleDuration (const WifiTxVector& txVector) const override;
+  Time GetHeaderDuration (const WifiTxVector& txVector) const override;
+
+  /**
+   * Create an ERP-OFDM mode from a unique name, the unique name
+   * must already be contained inside ModulationLookupTable.
+   * This method binds all the callbacks used by WifiMode.
+   *
+   * \param uniqueName the unique name of the WifiMode
+   * \param isMandatory whether the WifiMode is mandatory
+   * \return the ERP-OFDM WifiMode
+   */
+  static WifiMode CreateErpOfdmMode (std::string uniqueName, bool isMandatory);
+
+  static const ModulationLookupTable m_erpOfdmModulationLookupTable; //!< lookup table to retrieve code rate and constellation size corresponding to a unique name of modulation
+}; //class ErpOfdmPhy
+
+} //namespace ns3
+
+#endif /* ERP_OFDM_PHY_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/erp-ofdm-ppdu.cc ns-3.34/src/wifi/model/non-ht/erp-ofdm-ppdu.cc
--- ns-3.33/src/wifi/model/non-ht/erp-ofdm-ppdu.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/erp-ofdm-ppdu.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,59 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Rediet <getachew.redieteab@orange.com>
+ *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
+ */
+
+#include "ns3/wifi-psdu.h"
+#include "erp-ofdm-phy.h"
+#include "erp-ofdm-ppdu.h"
+#include "ns3/log.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("ErpOfdmPpdu");
+
+ErpOfdmPpdu::ErpOfdmPpdu (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector,
+                          WifiPhyBand band, uint64_t uid)
+  : OfdmPpdu (psdu, txVector, band, uid, true) //instantiate LSigHeader of OfdmPpdu
+{
+  NS_LOG_FUNCTION (this << psdu << txVector << band << uid);
+}
+
+ErpOfdmPpdu::~ErpOfdmPpdu ()
+{
+}
+
+WifiTxVector
+ErpOfdmPpdu::DoGetTxVector (void) const
+{
+  WifiTxVector txVector;
+  txVector.SetPreambleType (m_preamble);
+  NS_ASSERT (m_channelWidth == 20);
+  txVector.SetMode (ErpOfdmPhy::GetErpOfdmRate (m_lSig.GetRate ()));
+  txVector.SetChannelWidth (m_channelWidth);
+  return txVector;
+}
+
+Ptr<WifiPpdu>
+ErpOfdmPpdu::Copy (void) const
+{
+  return Create<ErpOfdmPpdu> (GetPsdu (), GetTxVector (), m_band, m_uid);
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/erp-ofdm-ppdu.h ns-3.34/src/wifi/model/non-ht/erp-ofdm-ppdu.h
--- ns-3.33/src/wifi/model/non-ht/erp-ofdm-ppdu.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/erp-ofdm-ppdu.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,70 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Rediet <getachew.redieteab@orange.com>
+ *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
+ */
+
+#ifndef ERP_OFDM_PPDU_H
+#define ERP_OFDM_PPDU_H
+
+#include "ofdm-ppdu.h"
+
+/**
+ * \file
+ * \ingroup wifi
+ * Declaration of ns3::ErpOfdmPpdu class.
+ */
+
+namespace ns3 {
+
+class WifiPsdu;
+
+/**
+ * \brief ERP-OFDM PPDU (11g)
+ * \ingroup wifi
+ *
+ * ErpOfdmPpdu stores a preamble, PHY headers and a PSDU of a PPDU with non-HT header,
+ * i.e., PPDU that uses ERP-OFDM modulation.
+ */
+class ErpOfdmPpdu : public OfdmPpdu
+{
+public:
+  /**
+   * Create an ERP-OFDM PPDU.
+   *
+   * \param psdu the PHY payload (PSDU)
+   * \param txVector the TXVECTOR that was used for this PPDU
+   * \param band the WifiPhyBand used for the transmission of this PPDU
+   * \param uid the unique ID of this PPDU
+   */
+  ErpOfdmPpdu (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector,
+               WifiPhyBand band, uint64_t uid);
+  /**
+   * Destructor for ErpOfdmPpdu.
+   */
+  virtual ~ErpOfdmPpdu ();
+
+  Ptr<WifiPpdu> Copy (void) const override;
+
+private:
+  WifiTxVector DoGetTxVector (void) const override;
+}; //class ErpOfdmPpdu
+
+} //namespace ns3
+
+#endif /* ERP_OFDM_PPDU_H */
